#define PAT_DATA_MAX	(64)
#define PMT_DATA_MAX	(32)
#define SECTION_MAX		(4096)

typedef struct {
	unsigned char table_id;
	unsigned char section_syntax_indicator;
	unsigned int section_length;
	unsigned int table_id_extention;
	unsigned char version_number;
	unsigned char current_next_indicator;
	unsigned char section_number;
	unsigned char last_section_number;
	union {
		struct {
			struct {
				unsigned int program_number;
				unsigned int pid;
			} data[PAT_DATA_MAX];
			int data_size;
		} pat;
		struct {
			unsigned int pcr_pid;
			unsigned int program_info_length;
			unsigned char *program_info; /* == sec + N */
			struct {
				unsigned char stream_type;
				unsigned int elementary_pid;
				unsigned int es_info_length;
				unsigned char *es_info; /* == sec + N */
			} data[PMT_DATA_MAX];
			int data_size;
		} pmt;
	} u;

	unsigned int pid;
	struct {
		int size;				/* == section_length + 3 */
		int current_size;
		unsigned char buf[SECTION_MAX];
	} section;
	IsdbDecode isdb_decode;
	unsigned char *isdb_buf;
} Psisidata;

#define GetPsisi(obj, psisi) {\
	Data_Get_Struct((obj), Psisidata, (psisi));\
	if ((psisi) == 0) rb_raise(rb_ePsisiError, "closed Psisi");\
}

enum {
	PAT = 0x00,
	PMT = 0x02,
	OTHER,
};

extern VALUE rb_cPsisi, rb_ePsisiError;

Psisidata *psisi_create(unsigned char *sec, int len, unsigned int pid);
void psisi_free(Psisidata *psisi);
int psisi_add(Psisidata *psisi, unsigned char *sec, int len);
VALUE psisi_make(Psisidata **psisi);

void Init_psisi(void);

/*
 * Local Variables:
 * c-basic-offset: 4
 * indent-tabs-mode: t
 * tab-width: 4
 * End:
 */
